/*
 *      #####################################################################
 *
 *        
 *        This software is provided 'as is', without warranty of any kind,
 *        express or implied. In no event shall the author be held liable
 *        for any damages arising from the use of this software.
 *
 *        Permission to use, copy, modify, and distribute this software and
 *        its documentation for non-commercial purposes is hereby granted,
 *        provided that the above copyright notice and this disclaimer appear
 *        in all copies and supporting documentation.
 *
 *        The software must NOT be sold or used as part of a any commercial
 *        or "non-free" product.
 *
 *      #####################################################################
 */

/*------------------------------------------------------------------------------
 *
 *  
 *
 */

#include <windows.h>
#include <windowsx.h>

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <conio.h>

#include <stdarg.h>
#include <tchar.h>

#include <commctrl.h>
#include <commdlg.h>

#include "pa_host.h"
#include "portaudio.h"
#include "dspmath.h"
#include "coeffs.h"
#include <complex.h>

#include "main.h"

#include "wsq_varicode tables.c"

int FS = 32000;
#define FPB           4 
#define FFT_SIZE_IN   16384// time domain input points for the FFT

#define NFFTPLOTPOINTS (FFT_SIZE_IN/4 + 1)  // number of bins in FFT output

#define SMOOTH_K    0.13333333

#define ASCII_XON       0x11 //for serial comms routine
#define ASCII_XOFF      0x13


  float   g_fltFftBufRe[FFT_SIZE_IN*2];       //buffers for FFT on raw input samples
  float   g_fltFftBufIm[FFT_SIZE_IN*2];
  float   g_fltPlotFftV[NFFTPLOTPOINTS*8];

  float   g_PlotPeak[65536];//NFFTPLOTPOINTS*8];

  float   peak_symbol;
  int     peak_index;
  float   sync[18];
 
  int     sync_start = 0;
  int     character;
  int     symbol;
  char    title[80], baud[80],comports[80],stopbit_s[80],parity[80], bitsperbyte_s[80];
  float   Signal_to_Noise;

  int     count_peaks;
  int     tone_number;
  int     peak_hits; 


  static int comport, baudrate, stopbits, bitsperbyte;
  char    szComportBuffer[256];
  HANDLE  hComm;

  char    synthesizer[33][80];

  long int   NumberofBytes = 0;         //number of bytes to save to wave file

  PortAudioStream   *g_PAStream;
  PortAudioStream   *g_PAStream_Send;

  BOOL   RXbutton              = TRUE;
  BOOL   TXbutton              = FALSE;
  BOOL   agc                   = TRUE;        //start with agc on to avoid being blasted with sound!
  BOOL   agcfast               = FALSE;
  BOOL   Pause                 = FALSE;
  BOOL   symbol_marker         = TRUE;
  BOOL   Pausebutton           = FALSE;
  BOOL   Synthesizer           = FALSE;
  BOOL   SpectrumAveragebutton = FALSE;
  BOOL   Blue                  = TRUE;


  const char g_szClassName[] = "WSQ";

  HWND    g_hwndRXbutton, g_hwndTXbutton, g_hwndPausebutton;

  HWND    hwnd;
  HWND    hwndTrack_brightness;

  HANDLE  hBitmapRX_ON, hBitmapTX_ON, hBitmapRX_OFF, hBitmapTX_OFF, hBitmapPause_ON, hBitmapPause_OFF; 

  HINSTANCE hThisInstance ;
  HINSTANCE g_hInst;
  HWND      hCtl;  
  HWND      hCtl_TX;
  HMENU     menu;               // Handle of the menu 

  HDC       hdcMem, hdcMem2, hdc2, hdcScroll;
  HBITMAP   hbmMem, hbmMem2, hbmOld,  hbmScroll, hbmScrollOld;

  HPEN      hPen, hOldPen;
  PAINTSTRUCT ps;
  RECT      rctClientArea, graph_rect, commands_rect;
  int       iXLoop;

  POINT     plotPoints[65536];//NFFTPLOTPOINTS*8]
  int       i; 
  COLORREF  brightness[65536];//NFFTPLOTPOINTS*8];

  char      sz80[84];
  int       iNumVisibleChars;
 
   
  float     ss, tmp, pk, agc_decay, agcthr, agcgain;
  int       hangcnt, k;  
     
  int       gain,  bright, contrast;
  float     noise_blank ;

  HFONT     RXfont;

  int       peak_counter, peak_index;

  FILE      *Wavfile;



int ChooseFile(HWND hParent, char * sResult)
{
	sResult[0] = 0;
	OPENFILENAME ofn;
	memset(&ofn, 0, sizeof(OPENFILENAME));
	ofn.lStructSize	= sizeof(OPENFILENAME);
	ofn.hInstance   = g_hInst;
	ofn.Flags		= OFN_FILEMUSTEXIST | OFN_PATHMUSTEXIST | OFN_HIDEREADONLY;
	ofn.hwndOwner	= hParent;
	ofn.lpstrFilter	= ("Setup Files Only (*setup*.txt)\0*setup*.txt\0All Files (*.*)\0*.*\0\0");
	ofn.lpstrTitle	= ("Select synthesizer setup file");
	ofn.lpstrFile			= sResult;
	ofn.nMaxFile			= MAX_PATH+100;
	ofn.lpstrCustomFilter	= NULL;
	ofn.nMaxCustFilter		= 0L;
	if (IDOK == GetOpenFileName(&ofn))
	{
		return 1;
	}
	return 0;
}
void Start_Portaudio();


void SerialPuts(HANDLE hComm, char *txstring)
{
	BOOL	        bWriteRC;
	static DWORD	iBytesWritten;

	if(hComm == NULL) return;

	bWriteRC = WriteFile(hComm, txstring, (DWORD) strlen(txstring), &iBytesWritten,NULL);
}

HANDLE SerialInit(char *ComPortName, DWORD BaudRate, int ByteSize, int StopBit, char ParityChar, char Protocol, int RxTimeOut, int TxTimeOut, int RxBufSize, int TxBufSize) 
{
	HANDLE			hCom;
	BOOL			bPortReady;
	DCB				dcb;
	COMMTIMEOUTS	CommTimeouts;
	int				Parity;

	switch(ParityChar) {
		case 'N':
		case 'n':
			Parity = NOPARITY;
			break;
		case 'E':
		case 'e':
			Parity = EVENPARITY;
			break;
		case 'O':
		case 'o':
			Parity = ODDPARITY;
			break;
		default:
			return NULL;	// illegal parameter !
	}
	
	switch(StopBit)
	{
		case 1:
			StopBit = ONESTOPBIT;
			break;
		case 2:
			StopBit = TWOSTOPBITS;
			break;
		default:
			return NULL;	// illegal parameter !
	}

	hCom = CreateFile(	ComPortName, 
						GENERIC_READ | GENERIC_WRITE,
						0,                 // exclusive access
						NULL,              // no security
						OPEN_EXISTING,
						0,                 // no overlapped I/O
						NULL);             // null template 

	if(hCom == INVALID_HANDLE_VALUE) return NULL;

	bPortReady = SetupComm(hCom, RxBufSize, TxBufSize); // set Rx and Tx buffer sizes

	// Port settings are specified in a Data Communication Block (DCB). 

	bPortReady = GetCommState(hCom, &dcb);

	dcb.BaudRate	= BaudRate;
	dcb.ByteSize	= ByteSize;
	dcb.Parity		= Parity;
	dcb.StopBits	= StopBit;
	dcb.fAbortOnError = TRUE;

	switch(Protocol) {
	case 'D':	// DTR/DSR
	case 'd':
		// set XON/XOFF
		dcb.fOutX	= FALSE;
		dcb.fInX	= FALSE;
		// set RTSCTS
		dcb.fOutxCtsFlow = FALSE;
		dcb.fRtsControl = RTS_CONTROL_DISABLE; 
		// set DSRDTR
		dcb.fOutxDsrFlow = TRUE;
		dcb.fDtrControl = DTR_CONTROL_HANDSHAKE; 
		break;
	case 'R':	// RTS/CTS
	case 'r':
		// set XON/XOFF
		dcb.fOutX	= FALSE;
		dcb.fInX	= FALSE;
		// set RTSCTS
		dcb.fOutxCtsFlow = TRUE;
		dcb.fRtsControl = RTS_CONTROL_HANDSHAKE; 
		// set DSRDTR
		dcb.fOutxDsrFlow = FALSE;
		dcb.fDtrControl = DTR_CONTROL_DISABLE; 
		break;
	case 'X':	// XON/XOFF
	case 'x':
		// set XON/XOFF
		dcb.fOutX	= TRUE;
		dcb.fInX	= TRUE;
		dcb.fTXContinueOnXoff = TRUE;
		dcb.XoffChar = ASCII_XOFF;
		dcb.XoffLim = RxBufSize - (RxBufSize / 4);
		dcb.XonChar = ASCII_XON;
		dcb.XonLim = RxBufSize - (RxBufSize / 2);
		// set RTSCTS
		dcb.fOutxCtsFlow = FALSE;
		dcb.fRtsControl = RTS_CONTROL_DISABLE; 
		// set DSRDTR
		dcb.fOutxDsrFlow = FALSE;
		dcb.fDtrControl = DTR_CONTROL_DISABLE;
		break;
	case 'N':	// NOPROTOCOL
	case 'n':
	default:
		// set XON/XOFF
		dcb.fOutX	= FALSE;
		dcb.fInX	= FALSE;
		// set RTSCTS
		dcb.fOutxCtsFlow = FALSE;
		dcb.fRtsControl = RTS_CONTROL_DISABLE; 
		// set DSRDTR
		dcb.fOutxDsrFlow = FALSE;
		dcb.fDtrControl = DTR_CONTROL_DISABLE; 
		break;
	}

	bPortReady = SetCommState(hCom, &dcb);

	// Set timeouts
	CommTimeouts.ReadIntervalTimeout = RxTimeOut;
	CommTimeouts.ReadTotalTimeoutMultiplier = 0;
	CommTimeouts.ReadTotalTimeoutConstant = RxTimeOut;

	CommTimeouts.WriteTotalTimeoutMultiplier = 0;
	CommTimeouts.WriteTotalTimeoutConstant = TxTimeOut;

	bPortReady = SetCommTimeouts(hCom, &CommTimeouts);

	return hCom;
}


/*-----------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------------*/

static LRESULT CALLBACK PTTDlgProc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{

//This sets up the comport for the PTT line
//Uses RTS and DTR just in case there are differences in rigs

    switch (uMsg)
    {
        case WM_INITDIALOG:
			{
  		      int i;
              char szTemp[256];

              for(i=0;i<100;i++)               //populate the comobobox with all possible comports
			   {
				wsprintf(szTemp,"%s%d", "COM",i);
				SendMessage(GetDlgItem(hwndDlg,IDM_PTT), CB_ADDSTRING, 0, (LPARAM)szTemp);
               }

				//Select the item in combobox that is the desired comport number
				SendMessage(GetDlgItem(hwndDlg,IDM_PTT), CB_SETCURSEL, comport, 0);			

               //make sure the window stays on top 
                SetWindowPos (hwndDlg, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE);   
   				
			}
			break;
	

		 case WM_COMMAND:
            switch (GET_WM_COMMAND_ID(wParam, lParam))
            {				
 
     		 case IDC_CANCEL:
                 EndDialog(hwndDlg, 0);
				break;  
    	
     		 case IDOK:
          /*      HANDLE SerialInit(char *ComPortName, 
						DWORD BaudRate, 
						int ByteSize,   = 8
						int StopBit,    = 1
						char ParityChar,= None, Even, Odd 
						char Protocol,  = N for RTS/DTR etc all turned off
						int RxTimeOut,  = 50msec?
						int TxTimeOut, 
						int RxBufSize, 
		      			int TxBufSize) 
         */


                  comport = SendMessage(GetDlgItem(hwndDlg,IDM_PTT),CB_GETCURSEL,0,0);
                  SendMessage(GetDlgItem(hwndDlg,IDM_PTT),CB_GETLBTEXT,comport, (LPARAM)szComportBuffer);

                  CloseHandle(hComm);               //close the comport(?) in case it is open
 
                 hComm = SerialInit( szComportBuffer, baudrate, bitsperbyte, stopbits, parity[0], 'N', 50, 50, 512, 512) ;
                  if (hComm == NULL)//INVALID_HANDLE_VALUE)
                      {
                        MessageBox(0,"Comport already open or no comport available","Comport Error",0);   //error occured alert user about error
                        return -1;
                      }
                 if (EscapeCommFunction(hComm,CLRDTR) == 0)              //clear RTS and DTR
                        MessageBox(0,"Error Clearing DTR","Comport Error",0); //should never get here but, just in case..

                 if (EscapeCommFunction(hComm,CLRRTS) == 0) 
                        MessageBox(0,"Error Clearing CTS","Comport Error",0);
       		 
  
                 EndDialog(hwndDlg, 0);
				break;

            }
            break;

        case WM_CLOSE:

            EndDialog(hwndDlg, 0);			
            return TRUE;
		 }

    return FALSE;
}
/*-----------------------------------------------------------------------------*/

/*------------------------------------------------------------------------------
 *
 *      Receive audio stream callback function
 *
 *      All receive audio processing is done in this function!
 *
 *      (No need to mess with a separate worker thread since this is
 *      already taken care of by PortAudio!)
 */

static int AudioCallback (void *inputBuffer,
                          void *outputBuffer,
                          unsigned long framesPerBuffer,
                          PaTimestamp outTime,
                          void *userData)
{
  unsigned long frameCnt;
  float         *out = (float *) outputBuffer;
  float         *in  = (float *) inputBuffer;
  float         leftInput, rightInput;

  float         rI44k;
  float         rI11k;
 
  float         rTmp;
  float         re,im;
  float         gainf;
  int           i, j;
  static int    k;

  static int    iFftBufIdxIn = 0;
  static unsigned int ui44kSampleCounter = 0;

  static int    iDecimatorIdxIn = 0;
  static float  rDecimatorQueueI[64];

  int           spec_ave, peak_smooth;

  static int    peak_val, prev_peak;
  static int    prev_symbol;
	

  static int    peak_counter;  
  int           peak = 0;

  double        val, max = 0.0;
  static int    last_peak;
  int           nibble;
  static int    MSB, LSB;

  static int    count;
  static float  input_windowed[FFT_SIZE_IN*2+1];
  static float  InputSamples[FFT_SIZE_IN*2+1];
  static float  input[FFT_SIZE_IN*2+1];
  double _Complex output[FFT_SIZE_IN*2+1];

  char          Char, curr_character, prev_character;
  int           nibble1, nibble2, nibble3;
  static int    curr_nibble, prev_nibble, prev2_nibble;

  double	    mag, max_mag;
  int	        max_index;
  int           low = 1750, high= 2515;
  int           low_limit = 2027, high_limit = 2205;


  static int    counts;

  static float  Noise, Signal;

// AGC parameters (based upon Winrad)------------------------------

  if (agcfast == FALSE)
     agc_decay = .9999; //slow agc
  else
     agc_decay = .9995; //fast agc

  agcthr = 60.e-5;
  agcgain = .05;
  agcgain = pow(agcgain, 2.2) * 2.;

// ----------------------------------------------------------------------------
  // Argument inputBuffer may be NULL during start-up so...

  if (inputBuffer == NULL)
    return 0;

  // Read input buffer, process data, and fill output buffer.

  for (frameCnt = 0; frameCnt < framesPerBuffer; frameCnt++)
    {
    // Get interleaved soundcard samples from input buffer
                             
    leftInput  = *in++;
    rightInput = *in++; // right channel not used but we must pick it anyway

// "Borrowed" from SAQrx.......

  // Decimation filter, R = 4, nTaps = 64 (hardcoded... ;-)

    if (--iDecimatorIdxIn < 0)  // fill buffer backwards (that convolution stuff...)
      iDecimatorIdxIn = 63;     // (well, the filter is symmetrical, but anyway...)

    rDecimatorQueueI[iDecimatorIdxIn] = leftInput;

    // Decimate Fs and do the heavy stuff at lower speed

    if (++ui44kSampleCounter >= 4)  // decimation factor = R = 4
    {
      ui44kSampleCounter = 0;

      // Fs = 11025 Hz code goes here, first decimation filter:

      rI11k  = 0.0;          // clear MAC accumulators
      for (i = 0; i < 64; i++)
      {
        rTmp = rDecIntCoeffs[i];
        rI11k += rDecimatorQueueI[iDecimatorIdxIn] * rTmp;
 
        if (++iDecimatorIdxIn >= 64)
          iDecimatorIdxIn = 0;
      }

      rI11k *= 1.0e-8;      // normalize (FIR gain ~10^8 !!!)

      // rI11k and rQ11k now contains the downsampled complex signal
      // ready for processing at Fs = 11025 Hz. Passband = +/-3000Hz
      // with transition bands out to +/-5512.5Hz (stopband).


     InputSamples[++k] = rI11k;

// ----------------------------------------------------------------------------

  if(SpectrumAveragebutton == TRUE)
           spec_ave = 3;
        else
           spec_ave = 1;
// ----------------------------------------------------------------------------
      
 		

     if(k == FFT_SIZE_IN/16)
       {

         for ( i = 0; i < FFT_SIZE_IN/16; i++) //circular buffer for symbol sync
          {  


// AGC section ---------------------------------------------------------------
	{
		tmp = fabs(InputSamples[i]);

		if(ss < tmp)
		{ ss = (9. * ss + tmp) / 10.;    // slow down attack time
		  pk = tmp;
		  hangcnt = (agcfast == TRUE) ? 1 : 6;
		}

		if(agc != FALSE)
		  InputSamples[i] *= 0.29 / max(ss, agcthr);
		else
		  InputSamples[i] *= 3.e3 * agcgain;

		if(hangcnt == 0)
		  ss  *= agc_decay;

		pk  *= agc_decay;
	}

	if(hangcnt > 0)  hangcnt--;
// ----------------------------------------------------------------------------
//  Move the samples along 1/16th of a symbol length at a time
			input[i]                     = input[i +   FFT_SIZE_IN/16];
			input[i +   FFT_SIZE_IN/16]  = input[i + 2*FFT_SIZE_IN/16];
			input[i + 2*FFT_SIZE_IN/16]  = input[i + 3*FFT_SIZE_IN/16];
			input[i + 3*FFT_SIZE_IN/16]  = input[i + 4*FFT_SIZE_IN/16];
            input[i + 4*FFT_SIZE_IN/16]  = input[i + 5*FFT_SIZE_IN/16];
            input[i + 5*FFT_SIZE_IN/16]  = input[i + 6*FFT_SIZE_IN/16];
	        input[i + 6*FFT_SIZE_IN/16]  = input[i + 7*FFT_SIZE_IN/16];
			input[i + 7*FFT_SIZE_IN/16]  = input[i + 8*FFT_SIZE_IN/16];
            input[i + 8*FFT_SIZE_IN/16]  = input[i + 9*FFT_SIZE_IN/16];
			input[i + 9*FFT_SIZE_IN/16]  = input[i + 10*FFT_SIZE_IN/16];
			input[i + 10*FFT_SIZE_IN/16] = input[i + 11*FFT_SIZE_IN/16];
			input[i + 11*FFT_SIZE_IN/16] = input[i + 12*FFT_SIZE_IN/16];
            input[i + 12*FFT_SIZE_IN/16] = input[i + 13*FFT_SIZE_IN/16];
            input[i + 13*FFT_SIZE_IN/16] = input[i + 14*FFT_SIZE_IN/16];
	        input[i + 14*FFT_SIZE_IN/16] = input[i + 15*FFT_SIZE_IN/16];
			input[i + 15*FFT_SIZE_IN/16] = input[i + 16*FFT_SIZE_IN/16];
            input[i + 16*FFT_SIZE_IN/16] = input[i + 17*FFT_SIZE_IN/16];			
			input[i + 17*FFT_SIZE_IN/16] = InputSamples[i];
/*
			input[i]                     = input[i +   FFT_SIZE_IN/32];
			input[i +   FFT_SIZE_IN/32]  = input[i + 2*FFT_SIZE_IN/32];
			input[i + 2*FFT_SIZE_IN/32]  = input[i + 3*FFT_SIZE_IN/32];
			input[i + 3*FFT_SIZE_IN/32]  = input[i + 4*FFT_SIZE_IN/32];
            input[i + 4*FFT_SIZE_IN/32]  = input[i + 5*FFT_SIZE_IN/32];
            input[i + 5*FFT_SIZE_IN/32]  = input[i + 6*FFT_SIZE_IN/32];
	        input[i + 6*FFT_SIZE_IN/32]  = input[i + 7*FFT_SIZE_IN/32];
			input[i + 7*FFT_SIZE_IN/32]  = input[i + 8*FFT_SIZE_IN/32];
            input[i + 8*FFT_SIZE_IN/32]  = input[i + 9*FFT_SIZE_IN/32];
			input[i + 9*FFT_SIZE_IN/32]  = input[i + 10*FFT_SIZE_IN/32];
			input[i + 10*FFT_SIZE_IN/32] = input[i + 11*FFT_SIZE_IN/32];
			input[i + 11*FFT_SIZE_IN/32] = input[i + 12*FFT_SIZE_IN/32];
            input[i + 12*FFT_SIZE_IN/32] = input[i + 13*FFT_SIZE_IN/32];
            input[i + 13*FFT_SIZE_IN/32] = input[i + 14*FFT_SIZE_IN/32];
	        input[i + 14*FFT_SIZE_IN/32] = input[i + 15*FFT_SIZE_IN/32];
			input[i + 15*FFT_SIZE_IN/32] = input[i + 16*FFT_SIZE_IN/32];
            input[i + 16*FFT_SIZE_IN/32] = input[i + 17*FFT_SIZE_IN/32];			
			input[i + 17*FFT_SIZE_IN/32]  = input[i + 18*FFT_SIZE_IN/32];
			input[i + 18*FFT_SIZE_IN/32]  = input[i + 19*FFT_SIZE_IN/32];
			input[i + 19*FFT_SIZE_IN/32]  = input[i + 20*FFT_SIZE_IN/32];
            input[i + 20*FFT_SIZE_IN/32]  = input[i + 21*FFT_SIZE_IN/32];
            input[i + 21*FFT_SIZE_IN/32]  = input[i + 22*FFT_SIZE_IN/32];
	        input[i + 22*FFT_SIZE_IN/32]  = input[i + 23*FFT_SIZE_IN/32];
			input[i + 23*FFT_SIZE_IN/32]  = input[i + 24*FFT_SIZE_IN/32];
            input[i + 24*FFT_SIZE_IN/32]  = input[i + 25*FFT_SIZE_IN/32];
			input[i + 25*FFT_SIZE_IN/32]  = input[i + 26*FFT_SIZE_IN/32];
			input[i + 26*FFT_SIZE_IN/32] = input[i + 27*FFT_SIZE_IN/32];
			input[i + 27*FFT_SIZE_IN/32] = input[i + 28*FFT_SIZE_IN/32];
            input[i + 28*FFT_SIZE_IN/32] = input[i + 29*FFT_SIZE_IN/32];
            input[i + 29*FFT_SIZE_IN/32] = input[i + 30*FFT_SIZE_IN/32];
	        input[i + 30*FFT_SIZE_IN/32] = input[i + 31*FFT_SIZE_IN/32];
			input[i + 31*FFT_SIZE_IN/32] = input[i + 32*FFT_SIZE_IN/32];
            input[i + 32*FFT_SIZE_IN/32] = InputSamples[i];
*/         } 

        for ( i = 0; i < FFT_SIZE_IN; i++) 
          {          
            g_fltFftBufRe[i] = input[i]*(0.42-0.5*cos(6.2832*(i)/FFT_SIZE_IN) + 0.08*cos(2*6.2832*(i)/FFT_SIZE_IN));//Blackman-Something window;
	      }

       //    dspmath_MultiplyBlackmanWindow (g_fltFftBufRe, FFT_SIZE_IN);

          dspmath_CalcRealFft (FFT_SIZE_IN, 
                               g_fltFftBufRe,    
                               g_fltFftBufIm) ;
    

		 k=0;
         max = 0.0; 
         peak =0; 

 

        for (i = low; i < high; ++i)
        {
            g_PlotPeak[i-low] = 0;
   
                re = g_fltFftBufRe[i];
		        im = g_fltFftBufIm[i];

          rTmp = spec_ave*SMOOTH_K * (sqrt(re*re+im*im) - g_fltPlotFftV[i-low]);
          g_fltPlotFftV[i-low] += rTmp; 
        }

//find the maximum bin
        for (i = low_limit; i < high_limit; ++i)
        {
          val =  g_fltPlotFftV[i-low];     
		  if(val > max)
            {
             max  = val;
			 peak = i-low;
            }           
        }

//find signal/noise ratio

  Noise = 0;

  for (i = low; i < high-185; ++i)  // why on earth did I subtract 185??
        {
         Noise += g_fltPlotFftV[i-low];         
        }
   Signal = (g_fltPlotFftV[peak-1] +g_fltPlotFftV[peak] + g_fltPlotFftV[peak+1]);
   Noise -= Signal;

   Signal_to_Noise = Signal/(Noise)*1.0;  //normalise to 3000Hz b/w??? - this agrees with PATHSIM simulations as is


//mark the peak symbol in yellow
            g_PlotPeak[peak] = 255;
			peak_symbol = g_fltPlotFftV[peak];



//now see if we have several peaks in a row, indicating the presence of a symbol
          peak_val =  peak;     
		  if(peak_val == prev_peak)peak_counter++;
			
           prev_peak = peak;

          if(peak_counter > peak_hits)  //more than 6 peaks (normally peak_hits = 6) out of a possible 16 indicates a symbol rather than noise
			{				
				symbol = peak;
				peak_counter = 0;  //reset counter ready for next symbol
			}
	

//determine the difference between current and previous symbol
           nibble =((float)(symbol/4) - (float)(prev_symbol/4));  //approx 0.5Hz per DFT bin and 2Hz tone spacing = 4 bins per tone spacing
        //  nibble =(((float)symbol - (float)prev_symbol)/3);  //this isn't as precise for some reason??
		//  nibble =(ceilf)((symbol - prev_symbol)/4); 
          if(nibble < 0) nibble = nibble + 33; //allow for wrap-around (17 tones for 16 tone differences)
	       nibble = nibble - 1;  //1 is added at the Jason TX end so need to subtract it here

           if(nibble < 0)goto skip;  //-1 is our idle symbol, indicating we already have our symbol
			                         //Wait for next one to arrive


//Varicode decoder
    curr_nibble = nibble;

//single-nibble characters

     if((prev_nibble < 29) & (curr_nibble < 29))  
		{
		   curr_character = wsq_varidecode[prev_nibble];

           if((curr_character<10)|(curr_character>127))curr_character = 31; //to avoid "bonk" sound (esp. ascii 7)
		   if((curr_character>10)&(curr_character<31))curr_character = 31;		                                                        //- substitute a non-printing character
	
      //make sure caret stays at end of text
           int text_length = SendMessage(hCtl, WM_GETTEXTLENGTH, 0, 0);  
           SendMessage(hCtl, EM_SETSEL, text_length, text_length);       
      //emulate a keypress using WM_CHAR (is this really legal?)                                                         
           SendMessage ( hCtl, WM_CHAR, curr_character, 0);         //this removes the cursor so              
		   SendMessage ( hwnd, WM_MOUSEMOVE, 0, 0);                 //counteract it by forcing a mouse move       
        }

//double-nibble characters

 
	 if((prev_nibble < 29) & (curr_nibble > 28)) 
 		{
		   curr_character = wsq_varidecode[prev_nibble * 32  + curr_nibble];

           if((curr_character<10)|(curr_character>127))curr_character = 31;
		   if((curr_character>10)&(curr_character<31))curr_character = 31;
	                			
           int text_length = SendMessage(hCtl, WM_GETTEXTLENGTH, 0, 0); 
           SendMessage(hCtl, EM_SETSEL, text_length, text_length);  
           SendMessage ( hCtl, WM_CHAR, curr_character, 0);              
		   SendMessage ( hwnd, WM_MOUSEMOVE, 0, 0);           
        }

 
     prev_nibble = curr_nibble;


//End of varidecoder
skip: 
           prev_symbol = symbol;

//display the waterfall each 1/16th of a symbol (= FFT length)
               InvalidateRect (hwnd,   // window handle
                      &graph_rect,     // redraw only the spectrum and waterfall area   // CONST RECT*, NULL => force redraw of entire client area
                      FALSE); 

//display the commands area values
               InvalidateRect (hwnd,   // window handle
                      &commands_rect,  // redraw only the commands area   // CONST RECT*, NULL => force redraw of entire client area
                      FALSE); 
    	}


    }

  }
		return 0; // a non-zero return will stop the stream
}

/*------------------------------------------------------------------------------
 *
 *      Audio stream callback function
 *
 *      All audio processing is done in this function!
 *
 *      (No need to mess with a separate worker thread since this is
 *      already taken care of by PortAudio!)
 */

static int SendAudioCallback (void *inputBuffer,
                          void *outputBuffer,
                          unsigned long framesPerBuffer,
                          PaTimestamp outTime,
                          void *userData)
{
  unsigned long frameCnt;
  float *out = (float *) outputBuffer;
  float *in = (float *) inputBuffer;

  int i, j;
  static int k; 
  static unsigned short ln, hn;
  static char ch, ch2;
  static float phase, send, fAngle;
  static short curslot, prevslot;
  static short tone, prevtone;
  int n1, n2, n3;
static int pause=0;

char buffer[34]; //to convert tone value into a character

    
  

  for (frameCnt = 0; frameCnt < framesPerBuffer; frameCnt++)
    {


     if(k++ >= FFT_SIZE_IN*8)         //get a new character every 4 seconds

		{
         k=0;
         int len = GetWindowTextLength(hCtl_TX) + 1;      // add 1 for the final NULL
         if (len > 1)
            {
             char buf[len];
    
             GetWindowText(hCtl_TX, buf, len);
         //... do stuff with text ...
             ch  = buf[0];                          //get first character in buffer
          

    n1 = (int) wsq_varicode[ch][0];
    n2 = (int) wsq_varicode[ch][1];




//With varicode
         
			 tone = (prevtone + n1 + 1) % 33;

       // include command to send frequency data to the synthesizer (how do I send the right info??)
             sprintf(buffer, "%s\r", synthesizer[tone+1]);  //convert integer into character for the serial comms
             if(Synthesizer == TRUE)SerialPuts(hComm, buffer);                     //need [tone+1] as synthesizer[0] is zero Hz 
/*
Comment from Murray
The only oddity I found is that when the synth is newly turned on (and will be on a default frequency) 
it might not make much sense the first time you start the program and then press transmit, 
but if you stop and start again, it seems to come right. I've not investigated why that is as yet.
Sure to be an A isn't listening to B or B isn't talking to A problem. 
*/
             SetWindowText(hCtl_TX, &buf[1]);  //move the text to send along one as we remove the first character
             SendMessage(hCtl_TX, EM_SETSEL, len, len); //put caret at end of text

       //echo the sent character to the receive screen
		
            if(buf[0]==13) goto NoExtraLF;     //echo only the CR           //from received text

            SendMessage ( hCtl, WM_CHAR, buf[0], 0);      //This hides the cursor so              
NoExtraLF:  SendMessage ( hwnd, WM_MOUSEMOVE, 0, 0);      //counteract it by forcing a mouse move

            }
//display the commands area 
               InvalidateRect (hwnd,   // window handle
                      &commands_rect,  // redraw only the commands area   // CONST RECT*, NULL => force redraw of entire client area
                      FALSE); 			 
        }

	     phase = 2*3.14159* (1000 + tone*1.953125) / FS;  //<<=====change this to suit mode 1.46484375
    //     phase = 2*3.14159* (1000 + tone*1.46484375) / FS; //3-bin tone spacing (no good)
	     send = sin(fAngle);
         fAngle = fAngle + phase;
	   	 if(fAngle>=(2*3.14159))fAngle = fAngle - 2*3.14159;    

                 *out++ = send;      
                 *out++ = send;

	     prevtone = tone;
         prevslot = curslot;


      if(k++ >= FFT_SIZE_IN*8)
		   
        {	 
         if((int) wsq_varicode[ch][1] > 28)                  //now do the lower nibble for JASON mode
		   {
            k=0;    
            tone = (prevtone + (int) wsq_varicode[ch][1]+ 1) % 33;

      // include command to send frequency data to the synthesizer
             sprintf(buffer, "%s\r", synthesizer[tone+1]);
             if(Synthesizer == TRUE)SerialPuts(hComm, buffer);

            prevtone = tone;
           }
//display the commands area 
               InvalidateRect (hwnd,   // window handle
                      &commands_rect,  // redraw only the commands area   // CONST RECT*, NULL => force redraw of entire client area
                      FALSE); 
        } 

         tone_number = tone;

}

		return 0; // a non-zero return will stop the stream
}

/*------------------------------------------------------------------------------
 *
 *      Reaction to WM_PAINT message  (some of which is "borrowed" from SAQrx)
 */

#define SPECFRAMEWIDTH  600
#define SPECFRAMEHEIGHT 400
#define CURVEHEIGHT     221
#define CURVESTARTX     60
#define CURVESTARTY     40+CURVEHEIGHT

#define SPECTRUM_MIN_DB -110.0
#define SPECTRUM_MAX_DB 0.0

LONG OnWmPaint (HWND hWnd)
 {
     
  float SignalStrength;

  int pixel_brightness, red, green, blue;

  HDC hDC;

  
  hDC = BeginPaint (hWnd, &ps);

  // Get the size of the program window's client area:
  //
  // NOTE! The coordinates returned by GetClientRect() are:
  //
  //   rctClientArea.left == rctClientArea.top == 0 (always)
  //
  //   rctClientArea.right = WIDTH of client area
  //   (rightmost visible X == rctClientArea.right-1
  //
  //   rctClientArea.bottom = HEIGHT of client area
  //   (bottommost visible Y == rctClientArea.bottom-1

  graph_rect.left   = 0;
  graph_rect.top    = 362;
  graph_rect.right  = 820;     //set up limited rectangle to invalidate
  graph_rect.bottom = 460;

  commands_rect.left   = 261;
  commands_rect.top    = 489;
  commands_rect.right  = 633;     //set up limited rectangle to invalidate
  commands_rect.bottom = 513;




  GetClientRect (hWnd, &rctClientArea);

  // Create a compatible device context (DC) for drawing off-screen:

  hdcMem = CreateCompatibleDC (((LPPAINTSTRUCT)(&ps))->hdc);
  
  // Create an off-screen bitmap to do the off-screen drawing on:

  hbmMem = CreateCompatibleBitmap (((LPPAINTSTRUCT)(&ps))->hdc,
                                   rctClientArea.right-rctClientArea.left,
                                   rctClientArea.bottom-rctClientArea.top);
 
  // Direct all drawing operations onto the off-screen bitmap:

  hbmOld = (HBITMAP) SelectObject (hdcMem, hbmMem);





 
  // We can now begin the drawing operations, first erase the background:

  FillRect (hdcMem, &rctClientArea, (HBRUSH) GetStockObject(DKGRAY_BRUSH));



//  SetBkMode(hdcMem, TRANSPARENT);       // alternatives: TRANSPARENT/OPAQUE
//  SetBkColor (hdcMem, 0x00000000);        // background for TextOut()

 

// HBRUSH hBrush_button = CreateSolidBrush (0x00805000);//(0x00B09000);//(0x00A07000);
//  HBRUSH hOldBrush = (HBRUSH)SelectObject (hdcMem, hBrush_button);
  SetBkMode(hdcMem, TRANSPARENT);  //so that numbers don;t have white boxes around them

 

 HANDLE vertFont,hOldFont;
  vertFont = CreateFont( 
          15,0,//   'height,width(default=0)
          900,0, //  'escapement(angle),orientation (1/10 degree)
          400, //_    'weight (default=0,normal=400,bold=700)
          FALSE, //_ 'Italic
          FALSE, //_ 'Underline
          FALSE, //_ 'StrikeThru
          ANSI_CHARSET, OUT_CHARACTER_PRECIS,// _
          CLIP_DEFAULT_PRECIS, PROOF_QUALITY,//_
          FIXED_PITCH | FF_MODERN,"Courier New" );

    hOldFont = SelectObject(hdcMem,vertFont);
    SetTextColor(hdcMem, 0x00F0C080); 
 //   TextOut (hdcMem, 10,450, "Brightness", 10);

    DeleteObject (SelectObject (hdcMem,hOldFont));





  // Draw waterfall display box and "status bar" :

  SetTextAlign (hdcMem, TA_RIGHT);
  SetTextColor(hdcMem, 0x00808080);
  hPen = CreatePen (PS_SOLID, 1, 0x00808080);
  hOldPen = (HPEN)SelectObject (hdcMem, hPen);

    
    MoveToEx (hdcMem, CURVESTARTX-6,   CURVESTARTY+105, NULL);
    LineTo (hdcMem, CURVESTARTX+760,   CURVESTARTY+105);
    LineTo (hdcMem, CURVESTARTX+760,   CURVESTARTY+198);
    LineTo (hdcMem, CURVESTARTX-6,     CURVESTARTY+198);
    LineTo (hdcMem, CURVESTARTX-6,     CURVESTARTY+105);

//Add frequency markers

  MoveToEx (hdcMem,153,459 , NULL);  //waterfall frequency markers 900Hz
  LineTo   (hdcMem,153, 465 );

  MoveToEx (hdcMem,256,459 , NULL);  //                            950Hz
  LineTo   (hdcMem,256, 465 );

  MoveToEx (hdcMem,358,459 , NULL);  //                            1000Hz
  LineTo   (hdcMem,358, 465 );

  MoveToEx (hdcMem,461,459 , NULL);  //                            1050Hz
  LineTo   (hdcMem,461, 465 );

  MoveToEx (hdcMem,563,459 , NULL);  //                            1100Hz
  LineTo   (hdcMem,563, 465 );

  MoveToEx (hdcMem,666,459 , NULL);  //                            1150Hz
  LineTo   (hdcMem,666, 465 );

  MoveToEx (hdcMem,768,459 , NULL);  //                            1200Hz
  LineTo   (hdcMem,768, 465 );


//Add frequency labels

 TextOut (hdcMem, 168, 465, " 900", 4);
 TextOut (hdcMem, 373, 465, "1000", 4);
 TextOut (hdcMem, 578, 465, "1100", 4);
 TextOut (hdcMem, 803, 465, "1200 Hz", 7);

  // Put long box for "status bar" along the bottom for controls below

  MoveToEx (hdcMem,5,488 , NULL);  
  LineTo   (hdcMem,820, 488 );
  LineTo   (hdcMem,820, 514 );
  LineTo   (hdcMem,5, 514 );
  LineTo   (hdcMem,5, 488 );

  MoveToEx (hdcMem,758,488 , NULL);  //put separator markers
  LineTo   (hdcMem,758, 514 );

  MoveToEx (hdcMem,696,488 , NULL);  //put separator markers
  LineTo   (hdcMem,696, 514 );

  MoveToEx (hdcMem,634,488 , NULL);  //put separator markers
  LineTo   (hdcMem,634, 514 );


  MoveToEx (hdcMem,260,488 , NULL);  //put separator markers
  LineTo   (hdcMem,260, 514 );




// Clean up

  SelectObject (hdcMem, hOldPen);
  DeleteObject (hPen);




  // Draw spectrum plot:

  hPen = CreatePen (PS_SOLID, 1, 0x00DDDDDD);//0x0000FF10L);
  hOldPen = (HPEN)SelectObject (hdcMem, hPen);

 // rPixelsPerdB = (float)(CURVEHEIGHT) / (SPECTRUM_MAX_DB-SPECTRUM_MIN_DB);
  
  SignalStrength = 0;    //Reset S meter to zero
  
  for (iXLoop = 0; iXLoop < 950; iXLoop+=1)
  {

      pixel_brightness =  (int) (g_fltPlotFftV[iXLoop] * bright * bright/100);

   
  if(Blue == TRUE)                        // Blue waterfall display
		{
         red = pixel_brightness;
         green = pixel_brightness * 256;
         blue = (pixel_brightness) * 256 * 256 * 2;
		}
	else                                  // Green waterfall display
		{
         red = pixel_brightness;
         green = pixel_brightness * 256 * 2;
         blue = (pixel_brightness) * 256 * 256;
		}


  
      if (red >255) red = 255;
      if (green >256*255) green = 256*255;
      if (blue >256*256*255) blue = 256*256*255;

      if(((g_PlotPeak[iXLoop] == 255) & (symbol_marker == TRUE)))
	//{ //mark the peaks in  yellow
		{
			red  = 255;
			green= 256*255;
			blue = 0;
		}
      
      brightness[iXLoop] = red + green + blue;  //save the amplitude for waterfall pixels later on 
      if (brightness[iXLoop]>16777215) brightness[iXLoop]=16777215;
  
       
 //   plotPoints[iXLoop].y = y;
  } // end for X...



//Display the received peak frequencies and the sent tones:

   SetTextColor (hdcMem, 0x0000A0A0);  //dark yellow
   SetTextAlign (hdcMem, TA_LEFT);

  if(TXbutton==TRUE)
		{
         if(Synthesizer==TRUE)
      	  {
            iNumVisibleChars = sprintf (sz80, "%s""%s","Synthesizer command   ",synthesizer[tone_number+1]);
            TextOut (hdcMem, 270, 493 , sz80, iNumVisibleChars);	  
	      }
         else
	      {
            iNumVisibleChars = sprintf (sz80, "%s""%0.2f""%s", "Audio frequency   ",1000+tone_number*1.953125," Hz");
            TextOut (hdcMem, 270, 493 , sz80, iNumVisibleChars);	  
          }
        }

  if(RXbutton==TRUE)
        {
            iNumVisibleChars = sprintf (sz80, "%s""%0.1f""%s", "Current peak   ",(float)(1700+symbol)/2," Hz");
            TextOut (hdcMem, 270, 493 , sz80, iNumVisibleChars);

            iNumVisibleChars = sprintf (sz80, "%s""%d", "Peak hits = ",peak_hits);
            TextOut (hdcMem, 530, 493 , sz80, iNumVisibleChars);
	  
        }



//Display the S/N meter reading===========================

	static float Sig_to_noise;

   Sig_to_noise = 20*log10(Signal_to_Noise);  
 
 
//First make the meter background box
  HBRUSH hBrush_SmeterBG = CreateSolidBrush (0x00505050);
  HBRUSH hOldSmeterBrushBG = (HBRUSH)SelectObject (hdcMem, hBrush_SmeterBG);   
  Rectangle (hdcMem, 5, 366, 30,460);


  SelectObject (hdcMem, hOldSmeterBrushBG);
  DeleteObject (hBrush_SmeterBG);  
  
  
  HBRUSH hBrush_SmeterGreen = CreateSolidBrush (0x0000B000);
  HBRUSH hOldSmeterBrushGreen = (HBRUSH)SelectObject (hdcMem, hBrush_SmeterGreen);   
  SetBkMode(hdcMem, TRANSPARENT);

  int signoise;
  signoise = 350-Sig_to_noise*2.5;
    if(signoise<366)signoise = 366;  //make sure green indicator rectangle stays wikthin the meter
    if(signoise>460)signoise = 460;
  Rectangle (hdcMem, 5, signoise, 30, 460); 
  SelectObject (hdcMem, hOldSmeterBrushGreen);
  DeleteObject (hBrush_SmeterGreen);  
  

  MoveToEx (hdcMem,5,453 , NULL);  //-30dB
  LineTo (hdcMem,30, 453 );

  MoveToEx (hdcMem,5,427 , NULL);  //-20dB
  LineTo (hdcMem,30, 427 );

  MoveToEx (hdcMem,5,403 , NULL);  //-10dB
  LineTo (hdcMem,30, 403 );

  MoveToEx (hdcMem,5,379 , NULL);  //0dB
  LineTo (hdcMem,30, 379 );

  
      
  hPen = CreatePen (PS_SOLID, 1, 0x000000FF);
  hOldPen = (HPEN)SelectObject (hdcMem, hPen);
 // SetBkMode(hdcMem, TRANSPARENT); 
  MoveToEx (hdcMem,5,440 , NULL);   //-25dB red marker
  LineTo (hdcMem,30, 440 );

  

HANDLE SmeterFont,hOldSmeterFont;
  SmeterFont = CreateFont( 
          13,0,//   'height,width(default=0)
          0,0, //  'escapement(angle),orientation (1/10 degree)
          400, //_    'weight (default=0,normal=400,bold=700)
          FALSE, //_ 'Italic
          FALSE, //_ 'Underline
          FALSE, //_ 'StrikeThru
          ANSI_CHARSET, OUT_CHARACTER_PRECIS,// _
          CLIP_DEFAULT_PRECIS, PROOF_QUALITY,//_
          FIXED_PITCH | FF_MODERN,"Courier New" );

    hOldSmeterFont = SelectObject(hdcMem,SmeterFont);
    SetTextColor(hdcMem, 0x00FFFFFF);//0x00F0C080); 

    TextOut (hdcMem, 32,448, "-30", 3);   
    TextOut (hdcMem, 32,422, "-20", 3);       
    TextOut (hdcMem, 32,398, "-10", 3);   
    TextOut (hdcMem, 32,374, "  0", 3);   
    TextOut (hdcMem, 32,363, " dB", 3); 

//Add label for signal-to-noise meter, for later on
  TextOut (hdcMem, 5, 462 , " Signal", 7);
  TextOut (hdcMem, 5, 474 , "to Noise", 8);

  TextOut (hdcMem, 180, 495 , "Brightness", 10);



    DeleteObject (SelectObject (hdcMem,hOldSmeterFont));



          SelectObject (hdcMem, hPen);
          DeleteObject (hPen);
          SelectObject (hdcMem, hOldPen);
          DeleteObject (hOldPen);
  

 //Draw waterfall  
      
 for (iXLoop = 0; iXLoop < 950; iXLoop++)
  {
    SetPixelV (hdcScroll, iXLoop, 0, brightness[iXLoop]);  
  }   


 
  BitBlt(hdcScroll,
         0, 0, 755, 85,//rctClientArea.left, rctClientArea.top,
        // rctClientArea.right-rctClientArea.left,
        // rctClientArea.bottom-rctClientArea.top,
         hdcScroll,
         0, -1,
         SRCCOPY); 



//move the waterfall down one line and blit it to memory
  BitBlt(hdcMem,
         60, 370, 755, 85,//rctClientArea.left, rctClientArea.top,
       //  rctClientArea.right-rctClientArea.left,
       //  rctClientArea.bottom-rctClientArea.top,
         hdcScroll,
         0, 1,   //<--1 to avoid showing the first line being updated
         SRCCOPY);

  // Draw IFK spectrum limit markers

  hPen = CreatePen (PS_SOLID, 1, 0x000000FFL);
  hOldPen = (HPEN)SelectObject (hdcMem, hPen);
    MoveToEx (hdcMem, 335, 370, NULL);
    LineTo (hdcMem, 335, 460 );

    MoveToEx (hdcMem, 514, 370, NULL);
    LineTo (hdcMem, 514, 460 );
   
  SelectObject (hdcMem, hOldPen);
  DeleteObject (hPen);

         
  // "Blit" the finished drawing to the physical screen:         
  BitBlt(((LPPAINTSTRUCT)(&ps))->hdc,
         rctClientArea.left, rctClientArea.top,
         640+500,490+300,//rctClientArea.right-rctClientArea.left,
         //rctClientArea.bottom-rctClientArea.top,
         hdcMem,
         0, 0,
         SRCCOPY);         

  // Done with off-screen bitmap and DC, get rid of them

  SelectObject (hdcMem, hbmOld);
  DeleteObject (hbmMem);
  DeleteDC (hdcMem);
  DeleteDC (hDC);

       
  EndPaint(hWnd, &ps);


  return 0L;          // WM_PAINT message sucessfully handled
}







/*------------------------------------------------------------------------------
 *
 *      Start Portaudio 
 */

void Start_Portaudio()
            {
                  char szErr80[84];                   
                  PaError PaInitresultCode;                         
                  Pa_StopStream (g_PAStream);    
                  Pa_Sleep( 500 );        //wait a while before restarting
                  
                 // Re-Initialize PortAudio subsystem

                 PaInitresultCode = Pa_Initialize ();
                 if (PaInitresultCode == paNoError)
                {
                 PaInitresultCode = Pa_OpenDefaultStream (
                     &g_PAStream,
                     2, 2,       // stereo input and output
                     paFloat32,  // most convenient format on a fast machine...
                     FS,         // sampling frequency
                     FPB, 0,  // FPB frames per buffer, let PA determine numBuffers
                     AudioCallback, // callback function
                     NULL);      // we have no user data pointer to pass to the callback for now
                if (PaInitresultCode == paNoError)
                  PaInitresultCode = Pa_StartStream (g_PAStream);
               }

               if (PaInitresultCode != paNoError)
               {
                 Pa_Terminate();
                 if (PaInitresultCode == paHostError)
                 {
                   MessageBox (hwnd, szErr80, "LMS", MB_APPLMODAL | MB_OK | MB_ICONEXCLAMATION);
                   PostQuitMessage (1);
                 }
                 else
                 {
                   MessageBox (hwnd, Pa_GetErrorText(PaInitresultCode), "LMS",
                               MB_APPLMODAL | MB_OK | MB_ICONEXCLAMATION);
                   PostQuitMessage (1);
                 }                 
               }
	
               }    

void Start_Portaudio_Send()
            {
                  char szErr80[84];                   
                  PaError PaInitresultCode;                         
                  Pa_StopStream (g_PAStream_Send);    
                  Pa_Sleep( 500 );        //wait a while before restarting
                  
                 // Re-Initialize PortAudio subsystem

                 PaInitresultCode = Pa_Initialize ();
                 if (PaInitresultCode == paNoError)
                {
                 PaInitresultCode = Pa_OpenDefaultStream (
                     &g_PAStream_Send,
                     2, 2,       // stereo input and output
                     paFloat32,  // most convenient format on a fast machine...
                     FS,         // sampling frequency
                     FPB, 0,  // FPB frames per buffer, let PA determine numBuffers
                     SendAudioCallback, // callback function
                     NULL);      // we have no user data pointer to pass to the callback for now
                if (PaInitresultCode == paNoError)
                  PaInitresultCode = Pa_StartStream (g_PAStream_Send);
               }

               if (PaInitresultCode != paNoError)
               {
                 Pa_Terminate();
                 if (PaInitresultCode == paHostError)
                 {
                   MessageBox (hwnd, szErr80, "LMS", MB_APPLMODAL | MB_OK | MB_ICONEXCLAMATION);
                   PostQuitMessage (1);
                 }
                 else
                 {
                   MessageBox (hwnd, Pa_GetErrorText(PaInitresultCode), "LMS",
                               MB_APPLMODAL | MB_OK | MB_ICONEXCLAMATION);
                   PostQuitMessage (1);
                 }                 
               }
	
               }      



/*------------------------------------------------------------------------------
 *
 *      Show About box
 */

void vShowAboutBox (HWND hwnd)
{
  MessageBox (hwnd,
              "Weak signal IFK sender/receiver with:\n"
              "- 28/32 varicode v3.0\n"
        	  "- serial port PTT\n"
              "- synthesizer control\n"
              "- selectable setup file\n"
              "- selectable peaks count\n"
              "- selectable waterfall colour\n"
              "\n"           
        	  "This version 26 December 2013\n"
              "Written by Con Wassilieff ZL2AFP\n\n"
              "Currently 0.512 baud\n"
            ,
              "About WSQ2 v1.0", 0);
}


/*------------------------------------------------------------------------------
 *
 *      Show Help box
 */

void vShowHelpBox (HWND hwnd)
{
  MessageBox (hwnd,
              "To be advised\n",

              "WSQ2 Help", 0);
}
   


/*------------------------------------------------------------------------------
 *
 *      Windows message callback handler
 *
 *      (This function is called by the Windows function's DispatchMessage() )
 */


LRESULT CALLBACK WindowProcedure (HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
  int i;

  static HBRUSH hBrush;  //MUST be static!
  static HBRUSH hBrushButton, hBrushButtonAlt, hBrushBorder;
  static HBRUSH hBrush_receive, hBrush_send;
  static HCURSOR hCursor, hCursorArrow;



//Serial comms setup parameters
  FILE *setupfile;
  DCB dcbSerialParams = {0};
  COMMTIMEOUTS timeouts = {0};

  
  int comport_default     = 1;    //default comport
  int baudrate_default    = 9600; //default baudrate for serial comms
  int stopbits_default    = 1;
  int bitsperbyte_default = 8;
  char parity_default[80];
       parity_default[0]  = 'N';
  char dummy[80];
  int index;
  char FileName[80];  //For opening a new setup file later on

/*
  if ((setupfile = fopen("setup.txt", "r")) == NULL)
		{
         setupfile = fopen("setup.txt", "w");
         fprintf(setupfile, "WSQ2 setup for serial comms and PTT\n\n");
         fprintf(setupfile, "%d\n", comport_default);
         fprintf(setupfile, "%d\n", baudrate_default);
         fprintf(setupfile, "%s\n", parity_default);
         fprintf(setupfile, "%d\n", bitsperbyte_default);
         fprintf(setupfile, "%d\n", stopbits_default);

		for (index=0;index<33;index++)
				fprintf(setupfile, "synthesizer data\n");
 
		 fprintf(setupfile, "%s\n\n\n\n", "");
         fprintf(setupfile, "Description of parameters above -\n-comport\n-baudrate\n-parity\n-bits\n-stopbits\n-remaining lines are synthesizer commands");
         fclose(setupfile);
        } 
  fclose(setupfile);
 
*/
				
                   
  switch (message)
  {
    case WM_CREATE:

    if ((setupfile = fopen("setup.txt", "r")) == NULL)  // Load comport and other details
	 {
       comport     = 1;
	   baudrate    = 9600;
       stopbits    = 1;
       bitsperbyte = 8;
	   parity[0]   = 'N';
     }
	else
     {
       setupfile = fopen("setup.txt", "r");    //this MUST be in here!
         fgets(title,80,setupfile);
         fgets(dummy,80,setupfile);
         fgets(comports, 80,setupfile);
         fgets(baud,80,setupfile);
         fgets(parity, 80, setupfile);
         fgets(bitsperbyte_s, 80, setupfile);
         fgets(stopbit_s,80,setupfile);

		for (index=0;index<33;index++)
				fgets(synthesizer[index],80,setupfile);

         fclose(setupfile);
 
       comport     = atoi(comports);  //convert character into integer
	   baudrate    = atoi(baud);
       stopbits    = atoi(stopbit_s);
       bitsperbyte = atoi(bitsperbyte_s);
     }


    peak_hits = 6;    //default "peaks hit parade" count         
         
    hCursor      =    LoadCursor(hThisInstance,IDC_SIZEWE );
    hCursorArrow =    LoadCursor(hThisInstance,IDC_ARROW);

    hBrush = CreateSolidBrush ( RGB(64, 64, 64) );           //a brush to colour the trackbars dark gray to match the background

    hBrush_receive = CreateSolidBrush ( RGB(250,230,160) );  //colour the receive screen yellow-ish
    hBrush_send    = CreateSolidBrush ( RGB(80,80,120) );    //colour the send screen blue-ish

//Create an owner drawn button and colours for same
        hBrushButton = CreateSolidBrush (0x00504000); 
        hBrushButtonAlt = CreateSolidBrush (0x00B09000);
        hBrushBorder =  CreateSolidBrush (0x00F0C080);
    
    	


//Create Send button =================================================
        
   g_hwndTXbutton = CreateWindowEx ( 
        0,                                    // no extended styles 
        "static",                             // class name 
        "Pass",                               // title (caption) 
        WS_CHILD | WS_VISIBLE | SS_BITMAP | SS_NOTIFY,// style
        450+250, 490,                         // position 
        110, 20,                              // size 
        hwnd,                                 // parent window 
        (HMENU) IDC_TX_BUTTON,                // control identifier (don't need it subsequently so make it NULL
        GetModuleHandle(NULL),                // instance 
        NULL                                  // no WM_CREATE parameter 
        ); 

hBitmapTX_OFF = LoadBitmap(g_hInst, "IMG_BITMAP_TX_OFF"); 
hBitmapTX_ON = LoadBitmap(g_hInst, "IMG_BITMAP_TX_ON");  
/* Set the button image*/ 
SendMessage(g_hwndTXbutton,STM_SETIMAGE, 0,(LPARAM) hBitmapTX_OFF); //Set default button to USB
     
        
        
//Create Receive button===============================================      
   g_hwndRXbutton = CreateWindowEx ( 
        0,                                   // no extended styles 
        "static",                            // class name 
        "PassAll",                           // title (caption) 
        WS_CHILD | WS_VISIBLE | SS_BITMAP | SS_NOTIFY,// | BS_AUTOCHECKBOX | BS_PUSHLIKE,
        512+250, 490,                        // position 
        110, 20,                             // size 
        hwnd,                                // parent window 
        (HMENU) IDC_RX_BUTTON,               // control identifier (don't need it subsequently so make it NULL
        GetModuleHandle(NULL),               // instance 
        NULL                                 // no WM_CREATE parameter 
        ); 

hBitmapRX_OFF = LoadBitmap(g_hInst, "IMG_BITMAP_RX_OFF");
hBitmapRX_ON = LoadBitmap(g_hInst, "IMG_BITMAP_RX_ON");  
/* Set the button image*/ 
SendMessage(g_hwndRXbutton,STM_SETIMAGE, 0,(LPARAM) hBitmapRX_ON);  


//Create Pause button==================================================      
   g_hwndPausebutton = CreateWindowEx ( 
        0,                                 // no extended styles 
        "static",                          // class name 
        "Pause",                           // title (caption) 
        WS_CHILD | WS_VISIBLE | SS_BITMAP | SS_NOTIFY,
        388+250, 490,                      // position 
        110, 20,                           // size 
        hwnd,                              // parent window 
        (HMENU) IDC_PAUSE_BUTTON,          // control identifier (don't need it subsequently so make it NULL
        GetModuleHandle(NULL),             // instance 
        NULL                               // no WM_CREATE parameter 
        ); 

hBitmapPause_OFF = LoadBitmap(g_hInst, "IMG_BITMAP_PAUSE_OFF");
hBitmapPause_ON = LoadBitmap(g_hInst, "IMG_BITMAP_PAUSE_ON");  
/* Set the button image*/ 
SendMessage(g_hwndPausebutton,STM_SETIMAGE, 0,(LPARAM) hBitmapPause_OFF);  





//Waterfall display brightness treackbar================================
 
    hwndTrack_brightness = CreateWindowEx ( 
        0,                                  // no extended styles 
        "MSCTLS_TRACKBAR32",                // class name 
        "Trackbar Control",                 // title (caption) 
        WS_CHILD | WS_VISIBLE | TBS_NOTICKS  | TBS_BOTH | TBS_HORZ,// style
        10, 492,                            // position 
        160, 20,                            // size 
        hwnd,                               // parent window 
        NULL,                               // control identifier (don't need it subsequently so make it NULL
        hThisInstance,                      // instance 
        NULL                                // no WM_CREATE parameter 
        ); 
  
   SendMessage(hwndTrack_brightness, TBM_SETRANGE, 
        (WPARAM) TRUE,                      // redraw flag 
        (LPARAM) MAKELONG(0, 100));         // min. & max. positions 
    SendMessage(hwndTrack_brightness, TBM_SETPAGESIZE, 
        0, (LPARAM) 10);                    // new page size 

    SendMessage(hwndTrack_brightness, TBM_SETPOS, 
        (WPARAM) TRUE,                      // redraw flag 
        (LPARAM) 25);                       //set initial brightness level
 
bright = SendMessage(hwndTrack_brightness, TBM_GETPOS, 0,0); //get the trackbar position         




//Waterfall display setup================================================
 
       hdc2 = GetDC(HWND_DESKTOP);   //Get a DC from somewhere for the waterfall display
 
       hdcScroll = CreateCompatibleDC (hdc2);
  
  // Create an off-screen bitmap to do the off-screen drawing on waterfall display:
  
       hbmScroll = CreateCompatibleBitmap (hdc2, 640+350, 1200); 
  // Direct waterfall drawing operations onto the off-screen bitmap:

       hbmScrollOld = (HBITMAP) SelectObject (hdcScroll, hbmScroll);
  




 // Initialize PortAudio subsystem========================================
      Start_Portaudio();                    //Start receiver
      Pa_StopStream (g_PAStream);           //temporarily stop receiver to avoid screen flicker 
                                            //when starting sender 

      Start_Portaudio_Send();               //Start sender
      Pa_StopStream (g_PAStream_Send);      //Stop sender until needed later

      Pa_StartStream (g_PAStream);          //Restart receiver
 
 
      // Start a periodic timer that posts a WM_TIMER message each 50ms

   //   SetTimer (hwnd, 0, 10000, NULL);
   //   SetTimer (hwnd, 1, 50, NULL);
      break;
 


 case WM_HSCROLL:

         
//waterfall brightness slider control     
     if (lParam == (int) hwndTrack_brightness)
     { 
        bright = SendMessage(hwndTrack_brightness, TBM_GETPOS, 0,0); //get the trackbar position              
        SetFocus(hwnd);    //set trackbar focus elsewhere to avoid having the focus box around the control
     }       
       
    break;






 case WM_CTLCOLORSTATIC: 

      return (int) hBrush;   //don't need to use SetBkColor as hBrush does it all
             
 case WM_CTLCOLOREDIT: //this one also works for a trackbar

 {

// control's window handle is lParam, not hWnd
  if((HWND)lParam==hCtl)  // Receive screen graphics
   {
// HDC of control is wParam
         SetTextColor((HDC)wParam, RGB(0,0,120)); 
         SetBkColor((HDC)wParam,RGB(250,230,160)); 
         SetBkMode((HDC)wParam,OPAQUE);
        
// return new background brush
     return (int) hBrush_receive;
   }

  if((HWND)lParam==hCtl_TX)  // Send screen graphics
   {
// HDC of control is wParam
         SetBkMode((HDC)wParam,OPAQUE);
         SetTextColor((HDC)wParam, RGB(255,255,0));
         SetBkColor((HDC)wParam,RGB(80,80,120));
// return new background brush
     return (int) hBrush_send;//(LRESULT)GetStockObject(WHITE_BRUSH);
   }
// just use the default settings otherwise
   return DefWindowProc(hwnd, message, wParam, lParam);
 }
         
 case WM_COMMAND:
           switch( wParam )
           {
                   
             case IDC_TX_BUTTON:
                    if(TXbutton == TRUE)
                        break;  
                       
                    else
                      {
   /* Set the ON button image*/ 
                       SendMessage(g_hwndTXbutton,STM_SETIMAGE, IMAGE_BITMAP,(LPARAM) hBitmapTX_ON);
                       SendMessage(g_hwndRXbutton, STM_SETIMAGE, IMAGE_BITMAP,(LPARAM) hBitmapRX_OFF);
                       SendMessage(g_hwndPausebutton, STM_SETIMAGE, IMAGE_BITMAP,(LPARAM) hBitmapPause_OFF); 
                       TXbutton = TRUE;
                       RXbutton = FALSE;
					   Pausebutton = FALSE;

                       SendMessage ( hCtl, WM_CHAR, 0xD, 0);  //Start a new line on the receive screen
                                                              //to put the sent echoed text (Hex D =  
                       Pa_StartStream (g_PAStream_Send);      //Start the sender
                       Pa_StopStream (g_PAStream);            //Stop the receiver

            // include command to send frequency data to the synthesizer
            // to set frequency to lowest non-zero tone when on transmit (ie turn the synth back on)
			// otherwise it will send zero Hz until the first character
                       char buffer_off[34]; //to convert tone value in to a character
                       sprintf(buffer_off, "%s\r", synthesizer[1]);
                       SerialPuts(hComm, buffer_off);

                       EscapeCommFunction(hComm,SETDTR);
                       EscapeCommFunction(hComm,SETRTS);
                      }
                    return 0;                   
                   
 
             case IDC_RX_BUTTON:
                    if(RXbutton == TRUE) //if already depressed then quit - we want to simulate radiobutton behaviour
                        break;  
                      
                    else
                      {
   /* Set the ON button image*/ 

                       SendMessage(g_hwndTXbutton,STM_SETIMAGE, IMAGE_BITMAP,(LPARAM) hBitmapTX_OFF);
                       SendMessage(g_hwndRXbutton, STM_SETIMAGE, IMAGE_BITMAP,(LPARAM) hBitmapRX_ON); 
                       SendMessage(g_hwndPausebutton, STM_SETIMAGE, IMAGE_BITMAP,(LPARAM) hBitmapPause_OFF); 
                       TXbutton = FALSE;
                       RXbutton = TRUE;
					   Pausebutton = FALSE;
                       SendMessage ( hCtl, WM_CHAR, 0xD, 0);  //Start a new line on the receive screen
                                                              //to separate received from sent text
                       Pa_StartStream( g_PAStream);           //Start the receiver
                       Pa_StopStream (g_PAStream_Send);       //Stop the sender
          

            // include command to send frequency data to the synthesizer
            // to set frequency to zero when on receive (ie turn the synth off)
                       char buffer_off[34]; //to convert tone value in to a character
                       sprintf(buffer_off, "%s\r", synthesizer[0]);
                       SerialPuts(hComm, buffer_off);
 
                       EscapeCommFunction(hComm,CLRDTR);
                       EscapeCommFunction(hComm,CLRRTS);          
                      }
                    return 0;               
                   
             case IDC_PAUSE_BUTTON:
                    if(Pausebutton == TRUE) //if already depressed then quit - we want to simulate radiobutton behaviour
                        break;  
                      
                    else
                      {
   /* Set the PASUE button image*/ 

                       SendMessage(g_hwndTXbutton,STM_SETIMAGE, IMAGE_BITMAP,(LPARAM) hBitmapTX_OFF);
                       SendMessage(g_hwndRXbutton, STM_SETIMAGE, IMAGE_BITMAP,(LPARAM) hBitmapRX_OFF); 
                       SendMessage(g_hwndPausebutton, STM_SETIMAGE, IMAGE_BITMAP,(LPARAM) hBitmapPause_ON); 

                       TXbutton = FALSE;
                       RXbutton = FALSE;
					   Pausebutton = TRUE;

                       Pa_StopStream( g_PAStream);            //Stop the receiver
                       Pa_StopStream (g_PAStream_Send);       //Stop the sender

            // include command to send frequency data to the synthesizer
            // to set frequency to zero when on receive (ie turn the synth off)
                       char buffer_off[34]; //to convert tone value in to a character
                       sprintf(buffer_off, "%s\r", synthesizer[0]);
                       SerialPuts(hComm, buffer_off);
 
                       EscapeCommFunction(hComm,CLRDTR);
                       EscapeCommFunction(hComm,CLRRTS);          
                      }
                    return 0;               
                   

 
           
             case IDM_MARKER_ON:  
                  {symbol_marker = TRUE;
                   CheckMenuItem(menu,IDM_MARKER_ON,MF_CHECKED);
				   CheckMenuItem(menu,IDM_MARKER_OFF,MF_UNCHECKED);}
                  return 0;

             case IDM_MARKER_OFF:  
                  {symbol_marker = FALSE;
                   CheckMenuItem(menu,IDM_MARKER_OFF,MF_CHECKED);
				   CheckMenuItem(menu,IDM_MARKER_ON,MF_UNCHECKED);}
                  return 0;        

             case IDM_3_PEAKS:  
                  {peak_hits = 3;
                   CheckMenuItem(menu,IDM_3_PEAKS,MF_CHECKED);
				   CheckMenuItem(menu,IDM_6_PEAKS,MF_UNCHECKED);}
                  return 0;

             case IDM_6_PEAKS:  
                  {peak_hits = 6;
                   CheckMenuItem(menu,IDM_6_PEAKS,MF_CHECKED);
				   CheckMenuItem(menu,IDM_3_PEAKS,MF_UNCHECKED);}
                  return 0;     
   
             case IDM_BLUE:  
                  {Blue = TRUE;
                   CheckMenuItem(menu,IDM_BLUE,MF_CHECKED);
				   CheckMenuItem(menu,IDM_GREEN,MF_UNCHECKED);}
                  return 0;

             case IDM_GREEN:  
                  {Blue = FALSE;
                   CheckMenuItem(menu,IDM_GREEN,MF_CHECKED);
				   CheckMenuItem(menu,IDM_BLUE,MF_UNCHECKED);}
                  return 0;        

             case IDM_AGC_FAST:  
                  {agcfast = TRUE;
                   CheckMenuItem(menu,IDM_AGC_FAST,MF_CHECKED);
				   CheckMenuItem(menu,IDM_AGC_SLOW,MF_UNCHECKED);}
                  return 0;

             case IDM_AGC_SLOW:  
                  {agcfast = FALSE;
                   CheckMenuItem(menu,IDM_AGC_SLOW,MF_CHECKED);
				   CheckMenuItem(menu,IDM_AGC_FAST,MF_UNCHECKED);}
                  return 0;                                                          
                  
             case IDM_SYNTHESIZER_ON:  
                  {Synthesizer = TRUE;
                   CheckMenuItem(menu,IDM_SYNTHESIZER_ON, MF_CHECKED);
				   CheckMenuItem(menu,IDM_SYNTHESIZER_OFF,MF_UNCHECKED);}
                  return 0;

             case IDM_SYNTHESIZER_OFF:  
                  {Synthesizer = FALSE;
                   CheckMenuItem(menu,IDM_SYNTHESIZER_OFF,MF_CHECKED);
				   CheckMenuItem(menu,IDM_SYNTHESIZER_ON, MF_UNCHECKED);}
                  return 0;                                                   



            case IDM_PTT_CONTROLS:
                    return DialogBox(hThisInstance, MAKEINTRESOURCE(DLG_PTT), NULL, (DLGPROC)PTTDlgProc);

            case IDM_FAST_SPECTRUM:
                    SpectrumAveragebutton = TRUE;
                    CheckMenuItem(menu,IDM_FAST_SPECTRUM,MF_CHECKED);
				    CheckMenuItem(menu,IDM_SLOW_SPECTRUM,MF_UNCHECKED);
                    return 0;

            case IDM_SLOW_SPECTRUM:
                    SpectrumAveragebutton = FALSE;
                    CheckMenuItem(menu,IDM_SLOW_SPECTRUM,MF_CHECKED);
				    CheckMenuItem(menu,IDM_FAST_SPECTRUM,MF_UNCHECKED);
                    return 0;
					

             case IDM_FILEOPEN:
       

                  ChooseFile(hwnd, FileName);

     if ((setupfile = fopen(FileName, "r")) == NULL)break;
   
         fgets(title,80,setupfile);  // Must read all of these in to keep the order correct
         fgets(dummy,80,setupfile);
         fgets(comports, 80,setupfile);
         fgets(baud,80,setupfile);
         fgets(parity, 80, setupfile);
         fgets(bitsperbyte_s, 80, setupfile);
         fgets(stopbit_s,80,setupfile);

		for (index=0;index<33;index++)
				fgets(synthesizer[index],80,setupfile);

         fclose(setupfile); 
		      
   //  MessageBox (0, synthesizer[2],"",0);
 
                  return 0; 
    


             case IDM_AUDIODEVICES:
                  ShellExecute(hwnd, "open", "rundll32.exe",
                                    "shell32.dll,Control_RunDLL mmsys.cpl,,2",NULL, SW_SHOWNORMAL);// 2 opens "Audio" tab directly
                  return 0;


             case IDM_HELPCONTENTS:
              //    vShowHelpBox (hwnd); 
                  ShellExecute(hwnd, "open", "WSQhelp.htm", NULL, NULL, SW_SHOWNORMAL);  
                  return 0;


             case IDM_HELPABOUT:
                  vShowAboutBox (hwnd);
   
                  return 0;

           }
           break;
           
    case WM_DESTROY:
   
      KillTimer (hwnd, 0);          // what if SetTimer() was never called? *#*

      Pa_StopStream (g_PAStream);   // result ignored...
      Pa_CloseStream (g_PAStream);	 
      Pa_Terminate ();
  
      CloseHandle(hComm);
      PostQuitMessage(0);
      break;

    case WM_TIMER:   // Not used
         switch (wParam)
         {
         case 0:    //redraw the spectrum and waterfall area only
   
               InvalidateRect (hwnd,   // window handle
                      &graph_rect,// redraw only the spectrum and waterfall area //NULL,   // CONST RECT*, NULL => force redraw of entire client area
                      FALSE); // FALSE => do not erase when BeginPaint() is called

                return 0L;
                
             
         }
 
    case WM_PAINT:

    //  return OnWmPaint (hwnd);
     OnWmPaint (hwnd);
     return 0;


 


    case WM_MOUSEMOVE:

          SetCursor(hCursorArrow);
          SetWindowLong (hwnd, DWL_MSGRESULT, 1);   //ensure mouse is default arrow if outside the spectrum display   
      return 0L;

    default:          /* for messages that we don't deal with */
      return DefWindowProc (hwnd, message, wParam, lParam);
  }

  return DefWindowProc (hwnd, message, wParam, lParam);
}


/*------------------------------------------------------------------------------
 *
 *      Window$ main()
 */


int WINAPI WinMain (HINSTANCE hThisInstance,
                    HINSTANCE hPrevInstance,
                    LPSTR lpszArgument,
                    int nShowHow )
{
                    
 
    InitCommonControls(); // loads common controls DLL 


g_hInst = hThisInstance; 
  //HWND hwnd;                // this is the handle for our window
  MSG messages;             // here messages to the application are saved
  WNDCLASSEX wc;            // data structure for the windowclass



 
  // Set up the main window

  wc.cbSize        = sizeof (WNDCLASSEX);
  wc.style         = CS_HREDRAW | CS_VREDRAW; // or 0?
  wc.lpfnWndProc   = WindowProcedure;
  wc.cbClsExtra    = 0 ;
  wc.cbWndExtra    = 0 ;
  wc.hInstance     = hThisInstance;
  wc.hIcon         = LoadIcon(hThisInstance,TEXT("PROGRAM_ICON"));
  wc.hCursor       = NULL;//LoadCursor (NULL, IDC_ARROW);
  wc.hbrBackground = (HBRUSH) (COLOR_BTNFACE);  // black
  wc.lpszMenuName  = NULL;          // no menu from a RESOURCE !
  wc.lpszClassName = g_szClassName;
  wc.hIconSm       = LoadIcon(hThisInstance,TEXT("PROGRAM_ICON"));

  if (!RegisterClassEx (&wc))//(HBRUSH)GetStockObject(BLACK_BRUSH);//
  {
    MessageBox (NULL, "Window Registration Failed!", "Error!",
                MB_ICONEXCLAMATION | MB_OK);
    return 0;
  }

  // The class is registered, let's create the program

  hwnd = CreateWindowEx (
           0,                             // use WS_EX_CLIENTEDGE for "sunken edge" (else 0)
           g_szClassName,                 // window class name
           "WSQ2 Weak Signal QSO by ZL2AFP",  // title Text
           WS_CAPTION | WS_SYSMENU | 
           WS_MINIMIZEBOX, //| WS_MAXIMIZEBOX | 
           //WS_OVERLAPPEDWINDOW,//WS_THICKFRAME,                
           CW_USEDEFAULT,                 // Windows decides the initial X position
           CW_USEDEFAULT,                 // Windows decides the initial Y position
           831,                           // The window's width INCLUDING BORDER FRAME!
           573,                           // The window's height INCLUDING BORDER FRAME!
           HWND_DESKTOP,                  // The window is a child-window to desktop
           NULL,                          // No menu
           hThisInstance,                 // Program instance handle
           NULL                           // No Window creation data
           );

// Textbox for received text
//int hFont = (int)GetStockObject(ANSI_VAR_FONT);

  HFONT   RXfont=CreateFont(20,10,0,0,700,FALSE,FALSE,FALSE,DEFAULT_CHARSET,OUT_OUTLINE_PRECIS,
                    CLIP_DEFAULT_PRECIS,ANTIALIASED_QUALITY, VARIABLE_PITCH,TEXT("Arial")); 


  hCtl = CreateWindowEx(0,
               "edit", "", 
              WS_CHILD | WS_VISIBLE | WS_CLIPSIBLINGS | WS_TABSTOP | ES_MULTILINE | ES_AUTOVSCROLL |WS_VSCROLL, 
               0, 0, 825, 289,
               hwnd, NULL, GetModuleHandle(""),  NULL);

  SendMessage (hCtl, WM_SETFONT,  (WPARAM) RXfont, MAKELPARAM(TRUE, 0));   


// Textbox for sending text
 hCtl_TX = CreateWindowEx(0,
               "edit", "", 
              WS_CHILD | WS_VISIBLE | WS_CLIPSIBLINGS | WS_TABSTOP | ES_MULTILINE | ES_AUTOVSCROLL |WS_VSCROLL, 
               0, 290, 825, 70,
               hwnd, NULL, GetModuleHandle(""),  NULL);



if (hwnd == NULL)
  {
    MessageBox (NULL, "Window Creation Failed!", "Error!",
                MB_ICONEXCLAMATION | MB_OK);
    return 0;
  }

  // Make the window visible on the screen

  ShowWindow (hwnd, SW_SHOW);//nShowHow );
//  UpdateWindow (hwnd);// not needed since we use a timer tick for redraw
{
    menu = LoadMenu(hThisInstance, MAKEINTRESOURCE(ID_MENU));
    SetMenu(hwnd, menu);  
}
 

  // Run the message loop. It will run until GetMessage() returns 0

  while (GetMessage (&messages, NULL, 0, 0) > 0)
  {
    // Translate virtual-key messages into character messages
    TranslateMessage (&messages);
    // Send message to WindowProcedure
    DispatchMessage (&messages);
  }

  // The program return-value is 0 - The value that PostQuitMessage() gave

  return messages.wParam;
}
